<?php
/** 
* @package Easy Facebook Comments 
* @version 1.0
* @author JoomBoost 
* @website	https://www.joomboost.com 
* @copyright Copyright © 2012 - 2017 JoomBoost 
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html 
**/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgContenteasyfbcomments extends JPlugin {
    
    public function __construct($subject, $params){
        
        parent::__construct($subject, $params);
    
    }   
    
	public function onContentPrepare($context, &$article, &$params, $limitstart) {

        if( JRequest::getWord( "view" ) == "article" ) { 

		    $app = JFactory::getApplication();
		    
		    if( $app->isAdmin() ) { return; }

		    $doc = JFactory::getDocument();
		    
		    if( $doc->getType() != "html" ) { return; }

			

			if( isset($article) == null || empty($article->id) || isset($this->params) == null ) { return; }  
 
			$comment = $this->prepareComment($params, $article);	
			if( $comment ) {
				$appId = $this->params->get('appId');
				if( $appId ) { $doc->setMetaData( 'fb:app_id', $appId ); }				
	    		$adminID = $this->params->get('adminID');     		
 				if( $adminID ) { $doc->setMetaData( 'fb:admins', $adminID ); }	
				$article->text .= $comment;
			}
    	}    	
	}
	
    private function prepareComment( &$params, &$article = null ){
                   
		// Exluded Articles
		$excludedCats    = $this->params->get( 'excludeCats' );
		//if( $excludedCats )    { array_map( "trim", $excludedCats = explode(',', $excludedCats) ); }
		//settype($excludedCats, 	  'array');
	
		if( in_array( $article->catid, $excludedCats ) ) { return false; }

        $appId = $this->params->get('appId');
        $datanumposts  	 = $this->params->get('data-num-posts');         
        $datawidth  	 = $this->params->get('data-width');  
        $datacolorscheme = $this->params->get('data-colorscheme'); 
        //$developerlink 	 = $this->params->get('developer-link');        
        
        
		if( $appId ) 			{ $appId = "&appId=".$appId; }
		if( $datanumposts ) 	{ $datanumposts = "data-num-posts='".$datanumposts."'"; }
		if( $datawidth ) 		{ $datawidth = "data-width='".$datawidth."'"; }
		if( $datacolorscheme )  { $datacolorscheme = "data-colorscheme='".$datacolorscheme."'"; }
		
		$mlang 					= $this->params->get('language','en_GB');
		$autolanguage			= $this->params->get('autolanguage','1');
		
		
		
		$jlang					= str_replace('-', '_', JFactory::getLanguage()->getTag());
		
		
		$fblangs 				= array("af_ZA","gn_PY","ay_BO","az_AZ","id_ID","ms_MY","jv_ID","bs_BA","ca_ES","cs_CZ","ck_US","cy_GB","da_DK","se_NO",
				"de_DE","et_EE","ثn_IN","en_PI",	"en_GB","en_UD","en_US","es_LA","es_CL","es_CO","es_ES","es_MX","es_VE","eo_EO","eu_ES","tl_PH",
				"fo_FO","fr_FR","fr_CA","fy_NL","ga_IE","gl_ES","ko_KR","hr_HR","xh_ZA","zu_ZA","is_IS","it_IT","ka_GE","sw_KE","tl_ST","ku_TR",
				"lv_LV","fb_LT","lt_LT","li_NL","la_VA","hu_HU","mg_MG","mt_MT","nl_NL","nl_BE","ja_JP","nb_NO","nn_NO","uz_UZ","pl_PL","pt_BR",
				"pt_PT","qu_PE","ro_RO","rm_CH","ru_RU","sq_AL","sk_SK","sl_SI","so_SO","fi_FI","sv_SE","th_TH","vi_VN","tr_TR","zh_CN","zh_TW",
				"zh_HK","el_GR","gx_GR","be_BY","bg_BG","kk_KZ","mk_MK","mn_MN","sr_RS","tt_RU","tg_TJ","uk_UA","hy_AM","yi_DE","he_IL","ur_PK",
				"ar_AR","ps_AF","fa_IR","sy_SY","ne_NP","mr_IN","sa_IN","hi_IN","bn_IN","pa_IN","gu_IN","ta_IN","te_IN","kn_IN","ml_IN","km_KH");
		
		
		
		$language				= (($autolanguage && in_array($jlang, $fblangs))) ? $jlang : $mlang; 
		       
        return "<div id='fb-root'></div>
				<script>(function(d, s, id) {
				  var js, fjs = d.getElementsByTagName(s)[0];
				  if (d.getElementById(id)) return;
				  js = d.createElement(s); js.id = id;
				  js.src = '//connect.facebook.net/".$language."/all.js#xfbml=1$appId';
				  fjs.parentNode.insertBefore(js, fjs);
				}(document, 'script', 'facebook-jssdk'));</script>
				
			<div class='fb-comments' data-href='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."' ".
					$datanumposts." ".$datawidth." ".$datacolorscheme."></div>";

    }
}
